# NOTE: Derived from blib/lib/Acme/Util.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Acme::Util;

#line 140 "blib/lib/Acme/Util.pm (autosplit into blib/lib/auto/Acme/Util/any.al)"
sub any(;$$$) {
    my $ref = shift || 1;

    unless (ref $ref) {
        my $end = shift;
        if ($end && ($end > $ref)) {
            # pick a random number between $start and $end inclusive
            my $span = ($end - $ref) + 1;
            return int(rand($span)) + $ref;
        } else { # ignore end if it's not greater than start
            return int(rand($ref + 1));
        }
    }

    my $pick = shift || 1;
    my $repl = shift || 0;
    $ref = [ keys (%$ref) ] if (hashref $ref);

    croak ("any: invalid reference '$ref': expected ARRAY or HASH")
        unless (arrayref $ref);

    my $last = $#$ref + 1;

    # make sure we're not trying to pick more items than the list
    # contains
    $pick = $#$ref + 1 if ($pick > $last);

    # don't bother modifying the list if we're only picking one item
    if ($pick == 1) {
        return $ref->[int(rand($last))];
    } else {
        my @any = ();
        if ($repl) {
            push @any, $ref->[int(rand($last))] for (1 .. $pick);
        } else {
            my @ref = @$ref; # don't modify the original list
	    for (1 .. $pick) {
		# squashed bug: recalculate $top every time the
		# array is spliced 
		my $top = $#ref + 1;
		push @any, splice (@ref, int(rand($top)), 1);
	    }
        }
        return wantarray ? @any : [ @any ];
    }
}

# end of Acme::Util::any
1;
