# NOTE: Derived from blib/lib/Acme/Util.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Acme::Util;

#line 983 "blib/lib/Acme/Util.pm (autosplit into blib/lib/auto/Acme/Util/reader.al)"
sub reader ($;%) {
    my ($file, %args) = @_;

    my ($die, $warn, $chomp) = @args{qw(DIE WARN CHOMP)};

    $die ||= \&_reader_die;
    $warn ||= \&_reader_warn;

    $die->("filename not defined") unless (defined $file);

    # Copy $/ before local() obliterates it below
    my $delim = $/;

    # Now $/ has been saved, we can override it if necessary
    # support aliases for the delimiter
    # tread carefully in case the delimiter is '' or 0
    for my $irs (qw(IRS DELIM SPLIT DELIMITER)) {
	next unless (exists $args{$irs});
	$delim = $args{$irs};
	last;
    }

    # $sg satisfies 3 requirements
    #	1. it's a lexical *reference* - needs to be a ref to give us a number
    #	2. it's referred to within the body of generator - a variable isn't
    #	   bound into a closure unless it's referred to
    #	3. it's private - the user is shielded from the implementation

    my $sg = Scope::Guard->new();
    my $handle = '_UTIL_READER_FH_' . int($sg);
	    
    {
	no strict 'refs';
	$die->("can't open <$file>: $!") unless (open($handle, $file));
	$handle = *$handle; # change $handle from a string into a filehandle
    }

    # wait until $handle is a filehandle before we guard it
    $sg->guard(\&myclose, $handle);

    unless (flock($handle, LOCK_SH)) {
	close $handle;
	$die->("Can't lock <$file>: $!");
    }

    # arg is optional but if supplied must be (or must be coercable into)
    # a scalar ref ... not that prototypes are honoured on subrefs... 
    my $generator = sub(;\$) {
	return unless ($sg);
	# ambient locals aren't (apparently) bound into closures
	local $/ = $delim;
	my $yield = $_[0] ? shift : \$_;

	if (defined ($$yield = readline($handle))) {
	    chomp ($$yield) if ($chomp);
	    return 1;
	} else {
	    flock ($handle, LOCK_UN); # release shared lock
	    # manually (indirectly) invoke the Scope::Guard dtor
	    return ($sg = undef);
	}
    };

    return $generator;
}

# end of Acme::Util::reader
1;
