# NOTE: Derived from blib/lib/Acme/Util.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Acme::Util;

#line 1095 "blib/lib/Acme/Util.pm (autosplit into blib/lib/auto/Acme/Util/readfile.al)"
sub readfile($;%) { # this prototype doesn't do what it says on the tin
    my ($file, %args) = @_;
    my ($die, $warn, $chomp) = @args{qw(DIE WARN CHOMP)};
    # tread carefully in case the delimiter is '' or 0
    my $delim;

    for my $irs (qw(IRS DELIM SPLIT DELIMITER)) {
	next unless (exists $args{$irs});
	$delim = $args{$irs};
	last;
    }

    $die ||= \&_readfile_die;
    $warn ||= \&_readfile_warn;

    $die->("filename not defined") unless (defined $file);

    my @lines = ();

    local (*FILE);
    if (open(FILE, $file)) {
	binmode FILE if ($args{BINARY} || $args{BINMODE});
	local ($/, $_);

	if (flock(FILE, LOCK_SH)) { # LOCK_SH
	    $/ = $delim if (defined $delim);
	    while (<FILE>) {
		chomp if ($chomp);
		push @lines, $_; 
	    }
	    flock(FILE, LOCK_UN); # release shared lock
	} else {
	    close FILE;
	    $die->("Can't lock <$file>: $!") 
	}
    } else {
	$die->("Can't open <$file>: $!");
    }

    $warn->("Can't close <$file>: $!") unless (close FILE);

    respond @lines;
}

# end of Acme::Util::readfile
1;
