# NOTE: Derived from blib/lib/Acme/Util.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Acme::Util;

#line 1375 "blib/lib/Acme/Util.pm (autosplit into blib/lib/auto/Acme/Util/writefile.al)"
sub writefile ($$;%) {
    my ($file, $data, %args) = @_;
    my ($die, $warn) = @args{qw(DIE WARN)};

    $die ||= \&_writefile_die;
    $warn ||= \&_writefile_warn;

    my $mode = (exists $args{MODE}) ? $args{MODE} : ($args{APPEND} ? '>>' : '>');
    my $status = 0; # true or false depending on print() to FILEHANDLE

    local (*FILE);

    if (open(FILE, "$mode$file")) {
	binmode FILE if ($args{BINARY} || $args{BINMODE});
	if (flock(FILE, LOCK_EX)) {
	    $status = print FILE $data;
	    flock(FILE, LOCK_UN); # release exclusive lock
	} else {
	    close FILE;
	    $die->("Can't lock <$file>: $!");
	}
    } else {
	$die->("Can't open <$file>: $!");
    }

    # This is strictly unneccessary, as local (*FOO) takes care of
    # closing the file automatically at end-of-scope 
    # But we'll use that as a lifesaver rather than a way of life
    $warn->("Can't close <$file>: $!") unless (close FILE);
    return $status;
}

# end of Acme::Util::writefile
1;
